#version 330 core

in vec2 UV;
in vec3 position;
in vec4 normal;

out vec4 outputColor;
out vec4 outputNormalDepth;

uniform sampler2D ModelTexture;

void main()
{
    vec4 color = texture(ModelTexture, UV);
    if(color.a == 0)
        discard;
    outputColor = vec4(color.rgb, 0);
    outputNormalDepth = vec4(normal.xyz, position.z);
}
