#version 330 core

uniform mat4 View;
uniform mat4 Projection;
uniform mat4 World;
uniform vec4 Tint;
uniform mat4 MVP;
uniform float FurLevel;
uniform float FurHeight;
uniform float NumFurLevels;
uniform vec3 FurGravity;
uniform vec3 FurVelocity;
uniform float Bloat;
uniform float Time;

layout (location = 0) in vec3 inPosition;
layout (location = 1) in vec4 inNormal;
layout (location = 2) in vec2 textureUV;

out vec2 UV;
out vec3 position;
out vec4 normal;

void main()
{
    float k = inNormal.w * (sin(Time + inPosition.y * 2 + inPosition.z * 2) + 1) * 0.25;
    vec3 pos = vec3(inPosition + k * (inNormal.xyz));
    pos.z += sin(Time * 4 + pos.y * 2) * 0.1 * k;
    pos.y += cos(Time * 3 + pos.z * 2) * 0.1 * k;
    //k = FurLevel / NumFurLevels;
    //pos = pos + ((vec4(FurGravity, 1) * World).xyz * k);
    pos = pos - ((vec4(FurVelocity, 1) * World).xyz * k * 4);

    vec2 bloatDir = normalize(textureUV - vec2(0.5, 0.5));
    
    gl_Position = MVP * vec4(pos, 1);
    UV = textureUV;
    position = (World * vec4(pos, 0)).xyz;
    normal = normalize(World * vec4(inNormal.xyz, 0));
    normal = normalize(World * vec4(pos - inPosition, 0));
}
