#version 330 core

uniform vec3 cameraPosition;

out vec4 outputColor;

uniform sampler2D DiffuseTexture;
uniform sampler2D PositionTexture;
uniform sampler2D NormalTexture;

uniform vec2 gScreenSize;

vec2 CalcTexCoord()
{
    return gl_FragCoord.xy / gScreenSize;
}

void main( void )
{
    vec2 UV = CalcTexCoord();

    vec3 ddd = texture(DiffuseTexture, UV).xyz;
    vec4 diffuse = texture(DiffuseTexture, UV);
    vec4 position = texture(PositionTexture, UV);
    vec4 normal = normalize(texture(NormalTexture, UV));

    vec3 light = vec3(-10, 0, 5);
    vec3 lightDir = normalize(light - position.xyz);

    vec3 eyeDir = normalize(cameraPosition - position.xyz);
    vec3 vHalfVector = normalize(lightDir.xyz + eyeDir);
    outputColor = max(dot(normal.xyz,lightDir),0) * diffuse + 
        pow(max(dot(normal.xyz,vHalfVector),0.0), 100) * 1.5;
    //outputColor = vec4(1,0,0,1);//normal;
    //outputColor = vec4(diffuse);
}

