#version 330 core

in vec2 UV;

layout(location = 0) out vec4 outputColor;

uniform sampler2D Texture;
uniform vec4 Color;
uniform vec2 SourceOffset;
uniform vec2 SourceSize;

void main()
{
    vec2 ST = UV;
    ST.x *= SourceSize.x;
    ST.y *= SourceSize.y;
    ST += SourceOffset;
    vec4 value = texture(Texture, ST).rgba;
    outputColor = vec4(value.rgb * Color.rgb, value.a);
}
