#version 330 core

in vec2 UV;
in vec3 position;
in vec4 normal;

out vec4 outputColor;
out vec4 outputNormalDepth;
out vec4 outputPosition;

uniform sampler2D ModelTexture;

uniform float FarClip;
uniform vec3 CameraPosition;

void main()
{
    outputColor = vec4(texture(ModelTexture, UV).rgb, 1);
    float fc = FarClip;
    outputNormalDepth = vec4(normal.xyz, position.z / FarClip);
    outputColor = vec4(0.8,0.8,0.9,0);
    outputPosition = vec4(position, 0);
}
