#version 330 core

uniform mat4 View;
uniform mat4 Projection;
uniform mat4 World;
uniform vec4 Tint;
uniform mat4 MVP;
uniform float FarClip;

layout (location = 0) in vec3 inPosition;
layout (location = 1) in vec4 inNormal;
layout (location = 2) in vec2 textureUV;

out vec2 UV;
out vec3 position;
out vec4 normal;

void main()
{
    vec3 worldPos = vec3(World * vec4(inPosition, 1));
    position = (View * vec4(worldPos, 1)).xyz;

    gl_Position = MVP * vec4(inPosition, 1);
    UV = textureUV;
    normal = World * vec4(inNormal.xyz, 0);
}
