#version 330 core

uniform mat4 View;
uniform mat4 Projection;
uniform mat4 World;
uniform vec4 Tint;
uniform mat4 MVP;
uniform float FarClip;

layout (location = 0) in ivec4 inPositionNormal;
layout (location = 1) in ivec4 inColor;

out vec4 color;
out vec3 position;
out vec4 normal;

void main()
{
    vec3 worldPos = (World * vec4(inPositionNormal.xyz, 1)).xyz;
    position = (View * vec4(worldPos, 1)).xyz;
    gl_Position = MVP * vec4(inPositionNormal.xyz, 1);
    if(inPositionNormal.a == 0)
    {
        normal = vec4(1,0,0,0);
    }
    else if(inPositionNormal.a == 1)
    {
        normal = vec4(-1,0,0,0);
    }
    else if(inPositionNormal.a == 2)
    {
        normal = vec4(0,11,0,0);
    }
    else if(inPositionNormal.a == 3)
    {
        normal = vec4(0,-1,0,0);
    }
    else if(inPositionNormal.a == 4)
    {
        normal = vec4(0,0,1,0);
    }
    else
    {
        normal = vec4(0,0,-1,0);
    }
    normal = World * normal;

    color = vec4(inColor.rgb, 0);
}
